<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>     
<script>
    //Vùng 1: Khai báo biến toàn cục, hằng số
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://42.115.221.44:8080/devcamp-lucky-dice/";
        const gUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";
    // Vùng 2: Vùng gán / thực thi hàm xử lý sự kiện cho các elements
    $(document).ready(function(){
        $("#btn-dice").click(function() {
            onBtnNemClick();
        })
    })
    // Vùng 3: Event handlers - Vùng khai báo các hàm xử lý sự kiện
    function onBtnNemClick() {
        //Tạo đối tượng để truyền dữ liệu giữa các bước
        var vUserObj = {
            username: "",
            firstname: "",
            lastname: ""
        }
        //B1: Thu thập dữ liệu
        getData(vUserObj);
        //B2: kiểm tra dữ liệu
        var vIsCheck = validateData(vUserObj);
        if(vIsCheck) {
            //console.log("Data hợp lệ!")
            var vXmlHttpGetDice = new XMLHttpRequest();
            //B3: gọi API server
            callAPIgetDice(vXmlHttpGetDice, vUserObj);
            vXmlHttpGetDice.onreadystatechange = function() {
            if(this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                //B4:Xử lý response trả về từ server        
                processResponse(vXmlHttpGetDice);
                }
            }
        }
    }
    //Vùng 4:- Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm thu thập dữ liệu
    function getData(paramUserObj) {
        paramUserObj.username = $("#inp-user-name").val().trim();
        paramUserObj.firstname = $.trim($("#inp-first-name").val()); 
        paramUserObj.lastname = $.trim($("#inp-last-name").val());
    }

    //hàm kiểm tra dữ liệu
    function validateData(paramUserObj) {
        if(paramUserObj.username == "") {
            alert("Cần nhập Username!");
            return false;
        }
        if(paramUserObj.firstname == "") {
            alert("Cần nhập Firstname!");
            return false;
        }
        if(paramUserObj.lastname == "") {
            alert("Cần nhập Lastname!");
            return false;
        }
        return true;
    }

    //Hàm callAPI get Dice
    function callAPIgetDice (paramXmlHttp,paramUserObj) {
        paramXmlHttp.open("post", gBASE_URL + "/dice", true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttp.send(JSON.stringify(paramUserObj)); //chuyển JSON obj sang string
    }

    //hàm xử lý response trả về thành công
    function processResponse(paramXmlHttpDice) {
        console.log(paramXmlHttpDice.responseText)
        //parsing JSON to Obj
        var vGetDiceObj = JSON.parse(paramXmlHttpDice.responseText);
        console.log(vGetDiceObj);
        //get result dice
        var vDiceResult = vGetDiceObj.dice;
        console.log("Dice result:= " + vDiceResult);
        //gọi hàm hiển thị Dice
        changeDiceImage(vDiceResult);
        //gọi hàm hiển thị lời nhắn
        changeNotification(vDiceResult);
        //gọi hàm hiển thị voucher
        changeVoucherId(vGetDiceObj);
        //gọi hàm hiển thị phần thưởng
        changeGift(vGetDiceObj);
    }

    //hàm hiển thị Dice theo result tung được
    function changeDiceImage(paramDiceResult) {
        var vImgDice = document.getElementById("img-dice");
        switch(paramDiceResult) {
            case 1:
                vImgDice.src = "LuckyDiceImages/1.png";
                break;
            case 2:
                vImgDice.src = "LuckyDiceImages/2.png";
                break;
            case 3:
                vImgDice.src = "LuckyDiceImages/3.png";
                break;
            case 4:
                vImgDice.src = "LuckyDiceImages/4.png";
                break;
            case 5:
                vImgDice.src = "LuckyDiceImages/5.png";
                break;
            default:
                vImgDice.src = "LuckyDiceImages/6.png";
        }
    }
    //hàm hiển thị lời nhắn
    function changeNotification(paramDiceResult) {
        var vNotice = $("#p-notification-dice")
        if(paramDiceResult <4) {
            vNotice.html("Chưa có quà rồi...Thử lần nữa nhé!")
        }
        else {
            vNotice.html("Wow! Chúc mừng bạn. Tung lần nữa nhé!")
        }
    }
    //hàm hiển thị Voucher
    function changeVoucherId(paramGetDiceObj) {
        var vPVoucherId = $("#p-voucher-id");
        var vPVoucherPercent = $("#p-voucher-percent");

        if(paramGetDiceObj.voucher != null) {
            vPVoucherId.html(paramGetDiceObj.voucher.maVoucher);
            vPVoucherPercent.html(paramGetDiceObj.voucher.phanTramGiamGia + "%");
        }
        else {
            vPVoucherId.html("");
            vPVoucherPercent.html("");
        }
    }
    //hàm hiển thị phần thưởng
   function changeGift(paramGetDiceObj) {
       var vImgPresent = $("#img-present");
       var vTenPhanThuong = paramGetDiceObj.prize;
       switch(vTenPhanThuong) {
            case "Mũ":
            vImgPresent.attr("src","LuckyDiceImages/hat.jpg");
            break;
            case "Xe Máy":
            vImgPresent.attr("src", "LuckyDiceImages/xe-may.jpg");
            break;
            case "Ô tô":
            vImgPresent.attr("src", "LuckyDiceImages/car.jpg");
            break;
            case "Xe đạp":
            vImgPresent.attr("src", "LuckyDiceImages/bike.jpg");
            break;
            case "Áo":
            vImgPresent.attr("src", "LuckyDiceImages/tshirt.jpg");
            break;
            default:
            vImgPresent.attr("src", "LuckyDiceImages/no-present.jpg");
       }
   }
   // sửa code theo task 44.40 add, commit, push lên bằng vscode
   //thay đổi code theo task 44.50, tạo branch develop
</script>

</html>